#!/usr/bin/env python
# -*- coding: latin-1; -*-

from __future__ import print_function
from builtins import str
from builtins import range
from katropton.eigenvalues import *
import os
import fwk

def main():
    file_dir = os.path.dirname(__file__)
    work_dir = os.getcwd()

    N = 32

    input_file_dir = file_dir + '/../../workspace/katropton_CMAME_tests_plate_MC_NO_EP/1/'
    
    i_min = 0
    i_max = N

    for i in range(i_min,i_max):
      timers = fwk.Timers()
      
      filename_Q = input_file_dir + str(i) + '/ApCTC_mm.txt'
      filename_GT = input_file_dir + str(i) + '/B_mm.txt'
      
      timers['Read files'].start()
      Q = read_mm(filename_Q)
      GT = read_mm(filename_GT)
      G =GT.transpose()
      timers['Read files'].stop()
      
      timers['Compute R'].start()
      R = approx_Schur_complement(Q,G,GT)
      timers['Compute R'].stop()
      
      print(timers)
      
      timers['Compute the inverse of Q'].start()
      invQG = compute_inv_on_image(Q,G)
      timers['Compute the inverse of Q'].stop()
      
      print(timers)
      
      timers['Compute the eigenvalues'].start()
      v = eigenvalues_SR(invQG,G,GT,R,True)
      timers['Compute the eigenvalues'].stop()
      
      print(timers)
      
      timers['Write the eigenvalues'].start()
      write_eigenvalues(v,work_dir+'/eigenvalues_direct_direct_'+ str(i) +'.txt')
      timers['Write the eigenvalues'].stop()

      f = open('timers_'+ str(i) +'.txt', 'w')
      print(timers, file=f)
      f.closed

if __name__ == "__main__":
    main()
