#!/usr/bin/env python
# -*- coding: latin-1; -*-

from __future__ import print_function
import katropton.utilities as u
import numpy as np
import os
import matplotlib
matplotlib.use('TkAgg') # <-- THIS MAKES IT FAST!
import matplotlib.pyplot as plt
from matplotlib import cm
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.tri as tri
from fwk.testing import *

def main():

    
    file_dir = os.path.dirname(__file__)

    
    npzfile = np.load(file_dir+'/mirror_data_1A.npz')
    x_1A = npzfile['x']
    y_1A = npzfile['y']
    z_1A = npzfile['z']
    sol_1A = npzfile['sol']
    tri_1A = npzfile['tri']
    dz_1A = npzfile['dz']

    npzfile = np.load(file_dir+'/mirror_data_1B.npz')
    x_1B = npzfile['x']
    y_1B = npzfile['y']
    z_1B = npzfile['z']
    sol_1B = npzfile['sol']
    tri_1B = npzfile['tri']
    dz_1B = npzfile['dz']

    npzfile = np.load(file_dir+'/mirror_data_2A.npz')
    x_2A = npzfile['x']
    y_2A = npzfile['y']
    z_2A = npzfile['z']
    sol_2A = npzfile['sol']
    tri_2A = npzfile['tri']
    dz_2A = npzfile['dz']

    npzfile = np.load(file_dir+'/mirror_data_2B.npz')
    x_2B = npzfile['x']
    y_2B = npzfile['y']
    z_2B = npzfile['z']
    sol_2B = npzfile['sol']
    tri_2B = npzfile['tri']
    dz_2B = npzfile['dz']
    
    x = x_1A
    y = y_1A
    tri = tri_1A
    dz = dz_1A
    levels = np.linspace(min(dz), max(dz), 15)
    # Velocity x-component
    fig = plt.figure(figsize=(8, 8))
    plt.set_cmap('jet')
    plt.tricontour(x, y, tri, dz, levels, linestyles='-',
                colors='black', linewidths=0.5)
    axtri = plt.tricontourf(x, y, tri, dz, levels, cmap='coolwarm')
    plt.plot(0.0365,0.017,'ko')
    plt.gca().set_aspect('equal')
    
    fig = plt.figure(figsize=(16,9))
    ax = fig.gca(projection='3d', proj_type = 'ortho')
    ax.plot_trisurf(x,y,dz,triangles=tri, cmap='coolwarm')
    plt.show()
    
    optical_coefficients_1A, dz_residual_1A = u.compute_RBM_Curvature_Irreg(x_1A,y_1A,z_1A,tri_1A,dz_1A,"m",np.array([0.0365,0.017]))
    
    optical_coefficients_1B, dz_residual_1B = u.compute_RBM_Curvature_Irreg(x_1B,y_1B,z_1B,tri_1B,dz_1B,"m",np.array([0.0365,0.017]))

    optical_coefficients_2A, dz_residual_2A = u.compute_RBM_Curvature_Irreg(x_2A,y_2A,z_2A,tri_2A,dz_2A,"m",np.array([0.0365,0.017]))
    
    optical_coefficients_2B, dz_residual_2B = u.compute_RBM_Curvature_Irreg(x_2B,y_2B,z_2B,tri_2B,dz_2B,"m",np.array([0.0365,0.017]))

    print(optical_coefficients_1A)
    print(optical_coefficients_1B)
    print(optical_coefficients_2A)
    print(optical_coefficients_2B)

if __name__ == "__main__":
    main()
