#ifndef WELEMENTCOMPUTATION_H
#define WELEMENTCOMPUTATION_H

#include "Stokhos_Sacado_Kokkos_MP_Vector.hpp"

#include <Kokkos_Core.hpp>
#include "Kokkos_ViewFactory.hpp"
#include "wCacheHex8.h"
#include "wCacheQuad4.h"
#include "wCacheTetra4.h"
#include "wCacheTri3.h"
#include "tMatrix.h"
#include "Sacado.hpp"
#include "Domain.h"

#include "Materials_list.h"
#include "Material.h"

#include "wElement.h"

#include "wLazy.h"
#include "tMatrix.h"

template <typename scalar, int element_type>
class ElementComputation
{
public:
    ElementComputation(){};

protected:
    tbox::CacheHex8 &trilinosHex8GetCache();
    tbox::CacheTetra4 &trilinosTetra4GetCache();
    tbox::CacheTri3 &trilinosTri3GetCache();
    tbox::CacheQuad4 &trilinosQuad4GetCache();

    double buildJ(int k, tMatrix<double, 3, 3> &J, local_ordinal_type e, const katropton::discrete_problem::Elements_list &elements_list, const katropton::discrete_problem::Nodes_list &nodes_list);
};

/*
template<typename scalar, int element_type> tbox::CacheHex8 & ElementComputation<scalar, element_type>::trilinosHex8GetCache();

template<typename scalar, int element_type> tbox::CacheTetra4 & ElementComputation<scalar, element_type>::trilinosTetra4GetCache();

template<typename scalar, int element_type> tbox::CacheTri3 & ElementComputation<scalar, element_type>::trilinosTri3GetCache();

template<typename scalar, int element_type> tbox::CacheQuad4 & ElementComputation<scalar, element_type>::trilinosQuad4GetCache();
*/
#endif //WELEMENTCOMPUTATION_H
