#ifndef WELEMENTVECTORS_H
#define WELEMENTVECTORS_H

#include <Kokkos_Core.hpp>
#include "Kokkos_ViewFactory.hpp"
#include "wCacheHex8.h"
#include "wCacheQuad4.h"
#include "wCacheTetra4.h"
#include "wCacheTri3.h"
#include "tMatrix.h"
#include "Domain.h"
#include "Loads.h"

#include "ElementComputation.h"

#include "Materials_list.h"
#include "Material.h"

#include "wLazy.h"
#include "tMatrix.h"

template <typename scalar, int element_type, int element_size>
class ElementVectors : public ElementComputation<scalar, element_type>
{
public:
    Kokkos::View<scalar **, Kokkos::LayoutRight> N;

    ElementVectors(){};
    ElementVectors(local_ordinal_type e, Teuchos::RCP<katropton::discrete_problem::Domain<scalar>> domain, Teuchos::RCP<katropton::discrete_problem::Loads<scalar>> loads, size_t numPrimalDPN);
};

#endif //WELEMENTVECTORS_H
