#ifndef WENSEMBLETRAITS_H
#define WENSEMBLETRAITS_H

#include "Sacado.hpp"
#include "Stokhos_Tpetra_Utilities_MP_Vector.hpp"

template <typename T>
struct EnsembleTraits
{
  static const int size = 1;
  typedef T value_type;
  static const value_type &coeff(const T &x, int i) { return x; }
  static value_type &coeff(T &x, int i) { return x; }
};

template <typename S>
struct EnsembleTraits<Sacado::MP::Vector<S>>
{
  static const int size = S::static_size;
  typedef typename S::value_type value_type;
  static const value_type &coeff(const Sacado::MP::Vector<S> &x, int i)
  {
    return x.fastAccessCoeff(i);
  }
  static value_type &coeff(Sacado::MP::Vector<S> &x, int i)
  {
    return x.fastAccessCoeff(i);
  }
};
#endif // WENSEMBLETRAITS
