#ifndef WGRAPH_H
#define WGRAPH_H

#include "katropton.h"

#include "Map.h"
#include "Elements_list.h"

#include <Tpetra_Map.hpp>
#include <Tpetra_Vector.hpp>
#include <Tpetra_CrsGraph.hpp>

#include <Teuchos_RCP.hpp>

typedef Tpetra::Vector<>::local_ordinal_type local_ordinal_type;
typedef Tpetra::Vector<>::global_ordinal_type global_ordinal_type;
typedef Tpetra::CrsGraph<local_ordinal_type, global_ordinal_type> crs_graph_type;

namespace katropton
{
namespace discrete_problem
{
class Graph
{
public:
    Teuchos::RCP<crs_graph_type> AWO;
    Teuchos::RCP<crs_graph_type> A;

    Graph();
    Graph(Teuchos::RCP<Map> map, Teuchos::RCP<Elements_list> elements_list);
};
}; // namespace discrete_problem
}; // namespace katropton

#endif //WGRAPH_H
