#ifndef WNODES_LIST_H
#define WNODES_LIST_H

#include "katropton.h"

#include "Map.h"

#include <Tpetra_Map.hpp>
#include <Tpetra_Vector.hpp>
#include <Teuchos_RCP.hpp>
#include <Kokkos_ViewFactory.hpp>

namespace katropton
{
namespace discrete_problem
{
class Nodes_list
{
public:
    Kokkos::View<double **, Kokkos::LayoutRight> nodes;

    Tpetra::Vector<>::local_ordinal_type nodes_number;

    Nodes_list();
    Nodes_list(Problem &pbl, Teuchos::RCP<Map> map);
};

}; // namespace discrete_problem
}; // namespace katropton

#endif //WNODES_LIST_H
