#ifndef WPREC_H
#define WPREC_H

#include <Teuchos_RCP.hpp>
#include "Teuchos_ParameterList.hpp"
/*

#include "Stokhos_Tpetra_MP_Vector.hpp"
#include "Stokhos_Tpetra_Utilities_MP_Vector.hpp"
#include "Tpetra_ConfigDefs.hpp"

#include "Tpetra_Map.hpp"
#include "Tpetra_MultiVector.hpp"
#include "Tpetra_Vector.hpp"
#include "Tpetra_CrsGraph.hpp"
#include "Tpetra_CrsMatrix.hpp"
#include "Stokhos_Tpetra_CG.hpp"



#include "Stokhos_MueLu_MP_Vector.hpp"
#include <MueLu.hpp>
#include <MueLu_TpetraOperator.hpp>
#include <MueLu_CreateTpetraPreconditioner.hpp>
#include <MueLu_Utilities.hpp>
*/

// Tpetra
#include "Stokhos_Tpetra_MP_Vector.hpp"
#include "Stokhos_Tpetra_Utilities_MP_Vector.hpp"
#include "Tpetra_ConfigDefs.hpp"

#include "Tpetra_Map.hpp"
#include "Tpetra_MultiVector.hpp"
#include "Tpetra_Vector.hpp"
#include "Tpetra_CrsGraph.hpp"
#include "Tpetra_CrsMatrix.hpp"
#include "Stokhos_Tpetra_CG.hpp"

// Belos solver
#include "Belos_Tpetra_MP_Vector.hpp"
#include "BelosLinearProblem.hpp"
#include "BelosPseudoBlockGmresSolMgr.hpp"
#include "BelosPseudoBlockCGSolMgr.hpp"

// Ifpack2 preconditioner
#include "Stokhos_Ifpack2_MP_Vector.hpp"
#include "Ifpack2_Factory.hpp"

// MueLu preconditioner
#include "Stokhos_MueLu_MP_Vector.hpp"
#include "MueLu_TpetraOperator.hpp"
#include "MueLu_CreateTpetraPreconditioner.hpp"

template <typename scalar>
Teuchos::RCP<MueLu::TpetraOperator<scalar>>
mueluPreconditioner(Teuchos::ParameterList mueluParams, Teuchos::RCP<const Tpetra::Operator<scalar>> C, Teuchos::RCP<Tpetra::MultiVector<double>> inCoords, Teuchos::RCP<Tpetra::MultiVector<scalar>> nullspace, std::string muelu_output_file)
{
    typedef Tpetra::Vector<scalar> TP_Vec;
    typedef typename TP_Vec::local_ordinal_type LO;
    typedef typename TP_Vec::global_ordinal_type GO;
    typedef typename TP_Vec::node_type NT;
    typedef MueLu::TpetraOperator<scalar, LO, GO, NT> muelu_tpetra_operator_type;

    std::ofstream muelu_ofstream(muelu_output_file);
    Teuchos::RCP<Teuchos::FancyOStream> verbOut = Teuchos::getFancyOStream(Teuchos::rcpFromRef(muelu_ofstream));
    //solverList.set("Output Stream",verbOut->getOStream ());
    //MueLu::BaseClass::SetDefaultOStream(verbOut);
    //Teuchos::RCP<Teuchos::FancyOStream> test = MueLu::BaseClass::GetDefaultOStream();

    Teuchos::RCP<Tpetra::Operator<scalar>> ncC = Teuchos::rcp_const_cast<Tpetra::Operator<scalar>>(C);
    Teuchos::RCP<muelu_tpetra_operator_type> M = MueLu::CreateTpetraPreconditioner<scalar, LO, GO, NT>(ncC, mueluParams); //, inCoords, nullspace);
    //Teuchos::RCP<muelu_tpetra_operator_type> M = MueLu::CreateTpetraPreconditioner<scalar,LO,GO,NT>(ncC, mueluParams);
    return M;
}

#endif //WPREC_H
