// global header of the "katropton" module

#ifndef KATROPTON_H
#define KATROPTON_H

#if defined(WIN32)
#ifdef tlnos_EXPORTS
#define KATROPTON_API __declspec(dllexport)
#else
#define KATROPTON_API __declspec(dllimport)
#endif
#else
#define KATROPTON_API
#endif

#include "tbox.h"

/**
 * @brief this namespace avoids conflicts with similar names in other modules
 */

namespace katropton
{
class Problem;
class Solver;
class uDirichlet;
class Neumann;
class Medium;
class Contact;
class Source;
class RandomVariable;
}; // namespace katropton

class DisplayHook;

#endif //KATROPTON_H
