#include "wMedium.h"
#include "wProblem.h"
#include "wTag.h"
using namespace katropton;
using namespace tbox;

Medium::Medium(Problem &pbl, int no, std::string _medium_name,
               std::vector<double> _E, std::vector<double> _nu, double _k, double _beta) : Group(pbl.msh, no), medium_name(_medium_name), k(_k), beta(_beta)
{
    E = _E[0];
    nu = _nu[0];
    E_vector = _E;
    nu_vector = _nu;
    pbl.media.push_back(this);
}

Medium::Medium(Problem &pbl, std::string const &name, std::string _medium_name,
               std::vector<double> _E, std::vector<double> _nu, double _k, double _beta) : Group(pbl.msh, name), medium_name(_medium_name), k(_k), beta(_beta)
{
    E = _E[0];
    nu = _nu[0];
    E_vector = _E;
    nu_vector = _nu;
    pbl.media.push_back(this);
}

void Medium::write(std::ostream &out) const
{
    out << "Medium " << medium_name << " on " << *tag << " with E=" << this->E << ", nu=" << this->nu << ", k=" << this->k << " and beta=" << this->beta;
}
