#ifndef WMEDIUM_H
#define WMEDIUM_H

#include "katropton.h"
#include "wGroup.h"
#include <string>
#include <vector>

namespace katropton
{

/**
 * @brief a thermomechanical medium : in progress
 */

class KATROPTON_API Medium : public tbox::Group
{
public:
    std::string medium_name;
    double E;
    std::vector<double> E_vector;
    std::vector<double> nu_vector;
    double nu;
    double k;
    double beta;
    Medium(Problem &pbl, int no, std::string _medium_name, std::vector<double> _E, std::vector<double> _nu, double _k = 0., double _beta = 0.);
    Medium(Problem &pbl, std::string const &name, std::string _medium_name, std::vector<double> _E, std::vector<double> _nu, double _k = 0., double _beta = 0.);

#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
};

} // namespace katropton

#endif //WMEDIUM_H
