#include "wProblem.h"
#include "wMshData.h"

#include "wuDirichlet.h"
#include "wNeumann.h"
#include "wSource.h"
using namespace katropton;
using namespace tbox;

Problem::Problem(std::shared_ptr<MshData> _msh, MPI_Comm _comm) : msh(_msh), comm(_comm)
{
}

void Problem::write(std::ostream &out) const
{
    out << "katropton::Problem:\n";
    out << " + mesh:\n";
    out << *msh; //wMshData.h

    out << " + dBC:\n";
    for (auto b : duBCs)
        out << *b << '\n';
    out << " + nBC:\n";
    for (auto b : nBCs)
        out << *b << '\n';
    out << " + Source:\n";
    for (auto b : Sources)
        out << *b << '\n';
}

int Problem::execute()
{
    int status = 0; // return status

    try
    {
        if (2 > 1)
            exit(0);
    }
    catch (int e)
    {
        std::cerr << "Caught exception, value = " << e << std::endl;
        status = 1;
    }
    return status;
}
