#ifndef WSOURCE_H
#define WSOURCE_H

#include "katropton.h"
#include "wGroup.h"
#include "wPt.h"
#include <vector>
#include <string>

namespace katropton
{

/**
 * @brief manage mechanical Dirichlet BC
 */

class KATROPTON_API Source : public tbox::Group
{
public:
    std::string const &Source_name;
    std::vector<tbox::Node *> nodes;
    double value;

    Source(Problem &pbl, std::string const &name, std::string const &_Source_name, double v_T);
#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
};

} // namespace katropton

#endif //WSOURCE_H
